/*
 * Copyright (c) 2008-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.
 *    
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *    
 *  * Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of Nokia Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *    
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 *    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *    
 *    Description:  
 */

#ifndef TZLOCALIZERAPPUI_H
#define TZLOCALIZERAPPUI_H

// INCLUDES
#include <eikapp.h>
#include <eikdoc.h>
#include <e32std.h>
#include <coeccntx.h>
#include <aknappui.h>
#include <eikdialg.h>
#include <TzLocalizationDataTypes.h>

// FORWARD DECLARATIONS
class CTZLocalizerDialog;
class CTZLocalizerEngine;


// CLASS DECLARATION
enum TCurrentlyShowing
    {
    EShowingNothing = 1,
    EShowingCity,
    EShowingCountry
    };


class CTZLocalizerAppUi : public CAknAppUi
    {
    public: // // Constructors and destructor

        void ConstructL();
        virtual ~CTZLocalizerAppUi();
        
    private:
        void DynInitMenuPaneL( TInt aResourceId,CEikMenuPane* aMenuPane );
    
        void FillListBoxL( CTzLocalizedCity* aLocalizedCity  );
    
        void FillListBoxL( CDesC16ArrayFlat* aArray );
    
        void ClearListBoxL();
        
        void ShowInfoL( const TPtrC aText );
    
        TBool QueryTextL( const TPtrC aPrompt, TDes& aReturn );
    
        TBool AskPopupChoiseL( const TPtrC aPrompt, 
            CDesC16ArrayFlat* aList, TDes& aReturn );
    
        void CreateNewCityL();
            
        void SearchCitiesL();
    
        void DeleteCityL();
            
        void HandleCommandL( TInt aCommand );
    
        virtual TKeyResponse HandleKeyEventL(
            const TKeyEvent& aKeyEvent,TEventCode aType);
    
        void SearchCitiesInGroupsL();
        void HandleResourceChangeL( TInt aType );
        
    private: //Data
        CTZLocalizerDialog* iAppDialog;
        CTZLocalizerEngine* iTzEngine;
    };

#endif

// End of File
